/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import com.aetrion.flickr.Flickr;
import com.aetrion.flickr.REST;
import com.aetrion.flickr.photos.Photo;
import com.aetrion.flickr.photos.PhotoList;
import com.aetrion.flickr.photos.PhotosInterface;
import com.aetrion.flickr.photos.SearchParameters;
import com.google.gdata.client.youtube.*;
import com.google.gdata.data.media.mediarss.MediaThumbnail;
import com.google.gdata.data.youtube.*;
import com.google.gdata.data.youtube.VideoFeed;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.URL;
import java.util.Iterator;
import java.util.List;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author Ludovic
 */
public class Search extends HttpServlet {

    // The name of the server hosting the YouTube GDATA feeds
    public static final String YOUTUBE_GDATA_SERVER =
            "http://gdata.youtube.com";
    // The URL of the "Videos" feed
    public static final String VIDEOS_FEED =
            YOUTUBE_GDATA_SERVER + "/feeds/api/videos";
    // The URL of the "Standard" feed
    public static final String STANDARD_FEED =
            YOUTUBE_GDATA_SERVER + "/feeds/api/standardfeeds/";

    private int totFlickr;
    private int totYoutube;

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        //RequestDispatcher dp = null;

        try {
            String searchTerms = request.getParameter("query");
            int nbrResult = Integer.parseInt(request.getParameter("n"));
            int indexResult = Integer.parseInt(request.getParameter("m"));
            
            YouTubeService service = new YouTubeService("gdataSample-YouTube-2");
            YouTubeQuery query = new YouTubeQuery(new URL(VIDEOS_FEED));
            query.setOrderBy(YouTubeQuery.OrderBy.RATING);

            

            query.setStartIndex(indexResult);
            query.setMaxResults(nbrResult);
            query.setFullTextQuery(searchTerms);

          //  dp = request.getRequestDispatcher("index.jsp");

            


             //FLickr
            out.write("<table border=0><tr><td>");
            Flickr flickr = new Flickr("47422029b3aabee4aca6a5853eca74b6", "ab7f2d30639a9828", new REST());
            PhotosInterface pi = flickr.getPhotosInterface();
            SearchParameters sp = new SearchParameters();


            String[] tabTag = searchTerms.split(" ");
            sp.setTags(tabTag);
            //sp.setText(searchTerms);

            

            PhotoList photoList = pi.search(sp, nbrResult, indexResult/nbrResult+1);

            totFlickr = photoList.getTotal();
            System.out.print("flickr" + totFlickr);
            Iterator it = photoList.iterator();
//            out.write("<div id=\"bar1\" dojoType=\"dojox.layout.ScrollPane\" "+
//                            " orientation=\"horizontal\"  style=\"width:600px; height:125px; border:0px solid #b7b7b7\">");
//
            out.write("<bar1><table border=0 class=\"photoBar\" cellpadding='2' cellspacing='0'><tr>");
            while (it.hasNext()) {


                out.write("<td >");
                Photo photo = (Photo) it.next();
                String titre = photo.getTitle().replaceAll("\"", "&quot;").replaceAll("'", "&acute;");

                String info = "";
                info += "<center><b>Photo</b></center>";
                info += "Titre : " + titre + "<br>";
           
                
                out.write("<a id=\""+photo.getId()+"\" onclick='showPhoto(\""+titre+"\",\""+photo.getSmallUrl()+"\")'>");
                out.write("<img style=\"margin-top:10px;\" onmouseover=\"showInfo('"+photo.getId()+"','"+info+"');\" onmousemove=\"showInfo('"+photo.getId()+"','"+info+"');\" src='" + photo.getThumbnailUrl() + "' />&nbsp;");
                out.write("</a>");
                out.write("</td>");
            }
            out.write("</tr></table></bar1>");
            out.write("</td></tr><tr><td>");

//            out.write("<div id=\"bar2\" dojoType=\"dojox.layout.ScrollPane\" "+
//                            " orientation=\"horizontal\"  style=\"width:600px; height:125px; border:0px solid #b7b7b7\">");

            out.write("<bar2><table  class=\"videoBar\" border=0><tr>");

            //Youtube


            VideoFeed videoFeed = service.query(query, VideoFeed.class);
            //System.out.println(videoFeed.getTotalResults());
            // See if the feed specifies a previous page of results.
            if (videoFeed.getPreviousLink() != null) {
                VideoFeed previousVideoFeed =
                        service.getFeed(new URL(videoFeed.getPreviousLink().getHref()),
                        VideoFeed.class);
            }

// See if the feed specifies a next page of results.
            if (videoFeed.getNextLink() != null) {
                VideoFeed nextVideoFeed = service.getFeed(new URL(videoFeed.getNextLink().getHref()),
                        VideoFeed.class);
            }

            if (videoFeed != null) {

               totYoutube= videoFeed.getTotalResults();
                System.out.print("Youtube " + totYoutube);
               
                for (VideoEntry ve : videoFeed.getEntries()) {
                    YouTubeMediaGroup mediaGroup = ve.getMediaGroup();

                    if (mediaGroup != null) {
                        String titre = ve.getTitle().getPlainText();
                        List<MediaThumbnail> thumbs = mediaGroup.getThumbnails();
                        ve.getEtag();

                        titre = titre.replaceAll("\"", "&quot;").replaceAll("'", "&acute;");
                        //out.write("<div class=\"video\">");                        
                        //Image thumbs
                        String info ="";
                        info += "<center><b>Video</b></center>";
                        info += "Titre : " + titre+"<br>";
                        info += "Durée : " + ve.getMediaGroup().getDuration()/60+":"+ String.format("%02d",ve.getMediaGroup().getDuration()%60)+"<br>";
                        info += "Uploader : " + ve.getMediaGroup().getUploader() +"<br>";
                        info += "Average Rating : " + ve.getRating().getAverage() +"<br>";
                        info += "View count : " + ve.getStatistics().getViewCount() +"<br>";

                       //System.out.println(info);
                        
                        out.write("<td valign='middle'><a id=\""+ve.getMediaGroup().getVideoId()+"\" onclick=\"showVideo('"+titre+"','"+ve.getMediaGroup().getVideoId()+"')\" >");
                        out.write("<img style=\"margin-top:10px;\" onmouseover=\"showInfo('"+ve.getMediaGroup().getVideoId()+"','"+info+"');\" onmousemove=\"showInfo('"+ve.getMediaGroup().getVideoId()+"','"+info+"');\" width='120' height='90' src=\"" + thumbs.get(0).getUrl() + "\"></a></td>");

                       // out.write("<div dojoType=\"dijit.Tooltip\" connectId=\""+ve.getMediaGroup().getVideoId()+"\" position=\"['above']\">"+info+"</div>");
                     
//                        out.write("<td>Titre "+titre+"</td>");
//                        //out.write("</div>");
//                         out.write("</tr>");
//                         out.write("<tr><td>Durée "+ve.getMediaGroup().getDuration()/60+":");
//                         out.format("%02d%n",ve.getMediaGroup().getDuration()%60);
//                         out.write(" Uploader "+ve.getMediaGroup().getUploader()+"</td></tr>");
//                         out.write("<tr><td>"+ve.getStatistics().getViewCount()+" vues depuis le "+ve.getPublished().toString().substring(0,ve.getPublished().toString().indexOf("T") )+"</td></tr>");
//                         out.write("<tr><td style=\"border-bottom-style:groove\">Rating : "+ve.getRating().getAverage()+"</td></tr>");
                    }
                }
                
             
            }
            out.write("</tr></table></bar2></td></tr>");
                out.write("</table>");
                out.write("</td></tr></table>");
            out.write("<search_results><span><b>Results for " + searchTerms + " from "+indexResult+" to "+(indexResult+nbrResult-1)+"</b> (Flick : "+totFlickr+")(Youtube : "+totYoutube+")</span></search_results>");
            //envoi du de la page JSP
            //dp.forward(request, response);

           
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            out.close();
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
